#include "yksikot.hh"
#include "yksikko.hh"

Yksikot::Yksikot()
{
	add("m",  'm');
	add("V",  'V');
	add("J",  'J');
	add("A",  'A');
	add("W",  'W');
	add("g",  'g');
	add("l",  'l');
	add("N",  'N');
	add("K",  'K'); // Kelvin
	add("ohm",'O'); // Ohmi
	add("F",  'F');
	add("H",  'H');
	add("C",  'C');
	add("s",  's');
	add("h",  'h');
	add("i",  'i'); // Imaginriyksikk!
	add("C", 'c'); // Ei kytss. Pelkstn laskentahilu...
	add("Pa", 'P');
	add("bar",'B');
	add("Hz", 'z');
	add("cd", 'd'); // Kandela (valovoima)
	add("mol",'o'); // Mooli
	add("toe",'t');
	add("'", '\''); // feet
	add("\"", '"'); // inch
	add("lbs",'b'); // 45.36
/* -- jtetn pois, sekaantuu vuorokausiin
	add("d",  'D'); // dioptri (linssin taittokyky)
*/
	add("lx", 'x'); // luksi (valaistusvoimakkuus)
}

Yksikkomuunnokset::Yksikkomuunnokset(Yksikot &Yksikot)
{
	tulop tmp;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["'"]), -1);
	(*this)[tmp] = 2.54*12;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["g"]),   1);
	tmp->insert(new yksikko(Yksikot["lbs"]),-1);
	(*this)[tmp] = 45.36;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["\""]),-1);
	(*this)[tmp] = 2.54;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["V"]), 1);
	tmp->insert(new yksikko(Yksikot["A"]), 1);
	tmp->insert(new yksikko(Yksikot["W"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["A"]),   1);
	tmp->insert(new yksikko(Yksikot["ohm"]), 1);
	tmp->insert(new yksikko(Yksikot["V"]),  -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["N"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["J"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["W"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["J"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["g"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]), -2);
	tmp->insert(new yksikko(Yksikot["N"]), -1);
	(*this)[tmp] = 0.001;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  3);
	tmp->insert(new yksikko(Yksikot["l"]), -1);
	(*this)[tmp] = 1000;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["N"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]), -3);
	tmp->insert(new yksikko(Yksikot["Pa"]), 1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["J"]),    1);
	tmp->insert(new yksikko(Yksikot["toe"]), -1);
	(*this)[tmp] = 40.6E9;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["Pa"]),  1);
	tmp->insert(new yksikko(Yksikot["bar"]),-1);
	(*this)[tmp] = 100000;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["Hz"]), 1);
	tmp->insert(new yksikko(Yksikot["s"]), -1);
	(*this)[tmp] = 1;
/*	tmp = new tulo; -- jtetn pois, sekaantuu vuorokausiin
	tmp->insert(new yksikko(Yksikot["d"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]), -1);
	(*this)[tmp] = 1;
*/	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["C"]),  1);
	tmp->insert(new yksikko(Yksikot["V"]), -1);
	tmp->insert(new yksikko(Yksikot["F"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["V"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["A"]), -1);
	tmp->insert(new yksikko(Yksikot["H"]), -1);
	(*this)[tmp] = 1;
/*	tmp = new tulo; -- onkos tm aivan oikein?
	tmp->insert(new yksikko(Yksikot["J"]),  1);
	tmp->insert(new yksikko(Yksikot["C"]), -1);
	tmp->insert(new yksikko(Yksikot["V"]), -1);
	(*this)[tmp] = 1;
*/	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["A"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["C"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["h"]), -1);
	(*this)[tmp] = 3600;
}
